/*
 * Created on 2004/06/03
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package happybirthday;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.OpenChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractCongraturationBehavior
*/
public abstract class AbstractCongraturationBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForTime =
			factory.createCompositeState("WaitingForTime");
		CompositeState waiting_For_Flower =
			factory.createCompositeState("Waiting For Flower");
		CompositeState waitingForReply =
			factory.createCompositeState("WaitingForReply");

		//actions
		Action givingFlowerAction = new Action() {
			public void doAction() {
				givingFlowerAction();
			}
			public String toString() {
				return "givingFlowerAction";
			}
		};
		Action sayingCongraturationAction = new Action() {
			public void doAction() {
				sayingCongraturationAction();
			}
			public String toString() {
				return "sayingCongraturationAction";
			}
		};
		Action receivingFlowerAction = new Action() {
			public void doAction() {
				receivingFlowerAction();
			}
			public String toString() {
				return "receivingFlowerAction";
			}
		};
		Action askingFlowerAction = new Action() {
			public void doAction() {
				askingFlowerAction();
			}
			public String toString() {
				return "askingFlowerAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionWaitingForReplyToWaitingForTime =
			factory.createTransition();
		Transition transitionWaiting_For_FlowerToWaitingForReply =
			factory.createTransition();
		Transition transitionWaitingForTimeToWaiting_For_Flower =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForTime =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForTime);
		this.addState(waiting_For_Flower);
		this.addState(waitingForReply);

		//transitions setting
		transitionWaitingForReplyToWaitingForTime.setEvent(
			OpenChannelEvent.class);
		transitionWaitingForReplyToWaitingForTime.addAction(
			sayingCongraturationAction);
		transitionWaitingForReplyToWaitingForTime.addAction(givingFlowerAction);
		transitionWaiting_For_FlowerToWaitingForReply.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_FlowerToWaitingForReply.addAction(
			receivingFlowerAction);
		transitionWaitingForTimeToWaiting_For_Flower.setEvent(TimeEvent.class);
		transitionWaitingForTimeToWaiting_For_Flower.addAction(
			askingFlowerAction);

		//connection of transitions
		transitionWaitingForReplyToWaitingForTime.setSourceState(
			waitingForReply);
		transitionWaitingForReplyToWaitingForTime.setTargetState(
			waitingForTime);
		transitionWaiting_For_FlowerToWaitingForReply.setSourceState(
			waiting_For_Flower);
		transitionWaiting_For_FlowerToWaitingForReply.setTargetState(
			waitingForReply);
		transitionWaitingForTimeToWaiting_For_Flower.setSourceState(
			waitingForTime);
		transitionWaitingForTimeToWaiting_For_Flower.setTargetState(
			waiting_For_Flower);
		transitionInitialStateToWaitingForTime.setSourceState(initialState);
		transitionInitialStateToWaitingForTime.setTargetState(waitingForTime);

	}

	/**
	*givingFlowerAction
	*/
	protected abstract void givingFlowerAction();
	/**
	*sayingCongraturationAction
	*/
	protected abstract void sayingCongraturationAction();
	/**
	*receivingFlowerAction
	*/
	protected abstract void receivingFlowerAction();
	/**
	*askingFlowerAction
	*/
	protected abstract void askingFlowerAction();
}
