/*
 * Created on 2004/06/03
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package happybirthday;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractShopingBehavior
*/
public abstract class AbstractShopingBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waiting_For_Time =
			factory.createCompositeState("waiting For Time");
		CompositeState waiting_For_Reply =
			factory.createCompositeState("Waiting For Reply");
		CompositeState wainting_For_Flower =
			factory.createCompositeState("Wainting For Flower");
		CompositeState waiting_For_Mother_s_Reply =
			factory.createCompositeState("Waiting For Mother's Reply");

		//actions
		Action receivingFlowerAction = new Action() {
			public void doAction() {
				receivingFlowerAction();
			}
			public String toString() {
				return "receivingFlowerAction";
			}
		};
		Action askPriceAction = new Action() {
			public void doAction() {
				askPriceAction();
			}
			public String toString() {
				return "askPriceAction";
			}
		};
		Action givingFlowerAction = new Action() {
			public void doAction() {
				givingFlowerAction();
			}
			public String toString() {
				return "givingFlowerAction";
			}
		};
		Action sayingCongratulationAction = new Action() {
			public void doAction() {
				sayingCongratulationAction();
			}
			public String toString() {
				return "sayingCongratulationAction";
			}
		};
		Action payingMoneyAction = new Action() {
			public void doAction() {
				payingMoneyAction();
			}
			public String toString() {
				return "payingMoneyAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionWaiting_For_ReplyToWainting_For_Flower =
			factory.createTransition();
		Transition transitionwaiting_For_TimeToWaiting_For_Reply =
			factory.createTransition();
		Transition transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time =
			factory.createTransition();
		Transition transitionWainting_For_FlowerToWaiting_For_Mother_s_Reply =
			factory.createTransition();
		Transition transitionInitialStateTowaiting_For_Time =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waiting_For_Time);
		this.addState(waiting_For_Reply);
		this.addState(wainting_For_Flower);
		this.addState(waiting_For_Mother_s_Reply);

		//transitions setting
		transitionWaiting_For_ReplyToWainting_For_Flower.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_ReplyToWainting_For_Flower.addAction(
			payingMoneyAction);
		transitionwaiting_For_TimeToWaiting_For_Reply.setEvent(TimeEvent.class);
		transitionwaiting_For_TimeToWaiting_For_Reply.addAction(askPriceAction);
		transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time.addAction(
			sayingCongratulationAction);
		transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time.addAction(
			givingFlowerAction);
		transitionWainting_For_FlowerToWaiting_For_Mother_s_Reply.setEvent(
			ChannelEvent.class);
		transitionWainting_For_FlowerToWaiting_For_Mother_s_Reply.addAction(
			receivingFlowerAction);

		//connection of transitions
		transitionWaiting_For_ReplyToWainting_For_Flower.setSourceState(
			waiting_For_Reply);
		transitionWaiting_For_ReplyToWainting_For_Flower.setTargetState(
			wainting_For_Flower);
		transitionwaiting_For_TimeToWaiting_For_Reply.setSourceState(
			waiting_For_Time);
		transitionwaiting_For_TimeToWaiting_For_Reply.setTargetState(
			waiting_For_Reply);
		transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time.setSourceState(
			waiting_For_Mother_s_Reply);
		transitionWaiting_For_Mother_s_ReplyTowaiting_For_Time.setTargetState(
			waiting_For_Time);
		transitionWainting_For_FlowerToWaiting_For_Mother_s_Reply
			.setSourceState(
			wainting_For_Flower);
		transitionWainting_For_FlowerToWaiting_For_Mother_s_Reply
			.setTargetState(
			waiting_For_Mother_s_Reply);
		transitionInitialStateTowaiting_For_Time.setSourceState(initialState);
		transitionInitialStateTowaiting_For_Time.setTargetState(
			waiting_For_Time);

	}

	/**
	*receivingFlowerAction
	*/
	protected abstract void receivingFlowerAction();
	/**
	*askPriceAction
	*/
	protected abstract void askPriceAction();
	/**
	*givingFlowerAction
	*/
	protected abstract void givingFlowerAction();
	/**
	*sayingCongratulationAction
	*/
	protected abstract void sayingCongratulationAction();
	/**
	*payingMoneyAction
	*/
	protected abstract void payingMoneyAction();
}
