 /*
 * HiroseYuukoModel.java
 */
package omedetou;

import org.boxed_economy.besp.container.BESPContainer;
import org.boxed_economy.besp.container.BESPPlugin;
import org.boxed_economy.besp.model.ModelContainer;
import org.boxed_economy.besp.model.fmfw.AgentType;
import org.boxed_economy.besp.model.fmfw.GoodsType;
import org.boxed_economy.besp.model.fmfw.BehaviorType;
import org.boxed_economy.besp.model.fmfw.InformationType;
import org.boxed_economy.besp.model.fmfw.RelationType; 

/**
 * Model for Boxed Economy Foundation Model Framework
 *
 * @generated modifiable
 * @version $$Id$$
 */
public class HiroseYuukoModel implements BESPPlugin {
	
	public static AgentType AGENTTYPE_FlowerStore;
	public static AgentType AGENTTYPE_CakeStore;
	public static AgentType AGENTTYPE_Children;
	public static AgentType AGENTTYPE_Mother;
	public static AgentType AGENTTYPE_mother;
	public static AgentType AGENTTYPE_children;
	public static BehaviorType BEHAVIORTYPE_SalesBehavior;
	public static BehaviorType BEHAVIORTYPE_SayingCongratulationBehavior;
	public static BehaviorType BEHAVIORTYPE_CongraturationBehavior;
	public static BehaviorType BEHAVIORTYPE_SayingThanksBehavior;
	public static BehaviorType BEHAVIORTYPE_givingPresentBehavior;
	public static BehaviorType BEHAVIORTYPE_takingPresentBehavior;
	public static RelationType RELATIONTYPE_favoriteFlowerStoreRelation;
	public static RelationType RELATIONTYPE_favoriteCakeStoreRelation;
	public static RelationType RELATIONTYPE_familyRelation;
	public static RelationType RELATIONTYPE_FamilyRelation;
	public static InformationType INFORMATIONTYPE_PriceInformation;
	public static InformationType INFORMATIONTYPE_QuestionInformation;
	public static GoodsType GOODSTYPE_FlowerGoods;
	public static GoodsType GOODSTYPE_MoneyGoods;
	public static GoodsType GOODSTYPE_PresentGoods;
	
	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	public static void initializePlugin(BESPContainer container) {
		installTypes(container);
		buildStructure(container);
		setPriority(container);
	}

	/** 
	* This method will be modified automatically by Model Editor
	*
	* @generated
	*/
	private static void installTypes(BESPContainer container) {
		//Get the model container  
		ModelContainer modelContainer = container.getModelContainer();
		
		AGENTTYPE_FlowerStore=modelContainer.installAgentType("happybirthday.FlowerStore");
		AGENTTYPE_CakeStore=modelContainer.installAgentType("happybirthday.CakeStore");
		AGENTTYPE_Children=modelContainer.installAgentType("happybirthday.Children");
		AGENTTYPE_Mother=modelContainer.installAgentType("happybirthday.Mother");
		AGENTTYPE_mother=modelContainer.installAgentType("omedetou.mother");
		AGENTTYPE_children=modelContainer.installAgentType("omedetou.children");
		BEHAVIORTYPE_SalesBehavior=modelContainer.installBehaviorType("happybirthday.SalesBehavior");
		BEHAVIORTYPE_SayingCongratulationBehavior=modelContainer.installBehaviorType("happybirthday.SayingCongratulationBehavior");
		BEHAVIORTYPE_CongraturationBehavior=modelContainer.installBehaviorType("happybirthday.CongraturationBehavior");
		BEHAVIORTYPE_SayingThanksBehavior=modelContainer.installBehaviorType("happybirthday.SayingThanksBehavior");
		BEHAVIORTYPE_givingPresentBehavior=modelContainer.installBehaviorType("omedetou.givingPresentBehavior");
		BEHAVIORTYPE_takingPresentBehavior=modelContainer.installBehaviorType("omedetou.takingPresentBehavior");
		RELATIONTYPE_favoriteFlowerStoreRelation=modelContainer.installRelationType("happybirthday.favoriteFlowerStoreRelation");
		RELATIONTYPE_favoriteCakeStoreRelation=modelContainer.installRelationType("happybirthday.favoriteCakeStoreRelation");
		RELATIONTYPE_familyRelation=modelContainer.installRelationType("happybirthday.familyRelation");
		RELATIONTYPE_FamilyRelation=modelContainer.installRelationType("omedetou.FamilyRelation");
		INFORMATIONTYPE_PriceInformation=modelContainer.installInformationType("happybirthday.PriceInformation");
		INFORMATIONTYPE_QuestionInformation=modelContainer.installInformationType("happybirthday.QuestionInformation");
		GOODSTYPE_FlowerGoods=modelContainer.installGoodsType("happybirthday.FlowerGoods");
		GOODSTYPE_MoneyGoods=modelContainer.installGoodsType("happybirthday.MoneyGoods");
		GOODSTYPE_PresentGoods=modelContainer.installGoodsType("omedetou.PresentGoods");
	}

	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	private static void buildStructure(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
	}

	/** 
	* Set priority 
	*
	* @generated modifiable
	*/	
	private static void setPriority(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
		//:TODO set priority
	}
}